exception Type_error of string
open Mini_java

type t

val add_class : t -> class_def -> t
val add_field : t -> Id.clazz -> fdecl -> t
val add_meth : t -> Id.clazz -> mdef -> t
val find_class : t -> Id.clazz -> class_def
val find_superclass : t -> Id.clazz -> class_def option
val find_superclass_until : t -> Id.clazz -> (class_def -> 'a option) -> 'a option
val find_field : t -> Id.clazz -> Id.field -> (class_def * fdecl)
val find_meth : t -> Id.clazz -> Id.meth -> (class_def * mdef)

type env
val add_var : env -> Id.var -> ty -> env
val find_var : env -> Id.var -> ty
